#include <stdio.h>
#include <stdlib.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>
#include <pthread.h>
#include <errno.h>
#include <stdexcept>

const char* _jmeno = "/chalupa-sdilena-pamet";
void* _pamet = nullptr;
bool _konec = false;
char _sz_cas[50];

void* thread_zapis(void* param)
{
	time_t cas;
	struct tm* timeinfo;
	while (!_konec)
	{
		cas = time(nullptr);
		timeinfo = localtime(&cas);
		strftime(_sz_cas, sizeof(_sz_cas), "%H:%M:%S", timeinfo);
		strcpy((char*)_pamet, _sz_cas);
		printf("%s - stiskni enter pro ukončení\n", _sz_cas);
		sleep(1);
	}
	strcpy((char*)_pamet, "server zastaven");
	return nullptr;
}

void* thread_cteni(void* param)
{
	while (!_konec)
	{
		strncpy(_sz_cas, (const char*)_pamet, sizeof(_sz_cas));
		printf("načteno: %s - enter pro ukončení\n", _sz_cas);
		sleep(1);
	}
	return nullptr;
}

int main(int argc, char **argv)
{
	bool mod_klient = false;
	if (argc > 1)
		mod_klient = (*argv[1] == 'k');
	int o_flags;
	int flags;
	off_t velikost_souboru = 1024;
	if (mod_klient)
	{
		o_flags = O_RDONLY;
		flags =  S_IROTH | S_IRUSR | S_IRGRP;
	}
	else
	{
		o_flags = O_RDWR | O_CREAT;
		flags =  S_IROTH | S_IRUSR | S_IWUSR | S_IRGRP;
	}
	int fd_soubor = 0;
	try
	{
		fd_soubor = shm_open(_jmeno, o_flags, flags);
		if (fd_soubor <= 0)
			throw std::runtime_error("chyba shm_open");
		if (!mod_klient)
		{
			if (0 != ftruncate(fd_soubor, velikost_souboru))
				throw std::runtime_error("chyba ftruncate");
		}
		_pamet = mmap(nullptr, velikost_souboru,
			mod_klient ? PROT_READ : PROT_READ | PROT_WRITE, MAP_SHARED, fd_soubor, 0);
		if ((void*)-1 == _pamet)
			throw std::runtime_error("chyba mmap");
		pthread_t p_thread;
		int iret = pthread_create(&p_thread, nullptr,
			mod_klient ? thread_cteni : thread_zapis, nullptr);
		if (iret) // při chybě vrátí nenulovou hodnotu
			throw std::runtime_error("chyba pthread_create");
		getchar();
		_konec = true;
		pthread_join(p_thread, nullptr);
		if (fd_soubor >= 0)
			close(fd_soubor);
		return EXIT_SUCCESS;
	}
	catch (const std::exception& v)
	{
		perror(v.what());
		if (fd_soubor >= 0)
			close(fd_soubor);
		return EXIT_FAILURE;
	}
}
